package main;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import org.jboss.ejb.client.EJBClient;

import xpctest.TestBean;

public class Main {
	public static void main(String[] args) throws Exception
	{
		final Hashtable<String,Object> jndiProperties = new Hashtable<String,Object>();
		jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		InitialContext ctx = new InitialContext(jndiProperties);

		TestBean testXPCSFSB1a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB1!xpctest.TestBean?stateful");
		TestBean testXPCSFSB1b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB1!xpctest.TestBean?stateful");
		TestBean testXPCSFSB2a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB2!xpctest.TestBean?stateful");
		TestBean testXPCSFSB2b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB2!xpctest.TestBean?stateful");
	    TestBean testTPCSFSB1a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestTPCSFSB1!xpctest.TestBean?stateful");
	    TestBean testTPCSFSB1b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestTPCSFSB1!xpctest.TestBean?stateful");
	    TestBean testTPCSFSB2a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestTPCSFSB2!xpctest.TestBean?stateful");
	    TestBean testTPCSFSB2b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestTPCSFSB2!xpctest.TestBean?stateful");
	    TestBean testSLSB1a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestSLSB1!xpctest.TestBean");
	    TestBean testSLSB1b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestSLSB1!xpctest.TestBean");
	    TestBean testSLSB2a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestSLSB2!xpctest.TestBean");
	    TestBean testSLSB2b = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestSLSB2!xpctest.TestBean");
		
	    // first, without user transaction
	    System.out.println("Test without user transaction");
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    System.out.println(testXPCSFSB2b.helloWorld("testXPCSFSB2b"));

	    // now the same, but with user transaction
	    UserTransaction ut = EJBClient.getUserTransaction("xpctest");

	    ut.begin();
					
	    try {
	    	System.out.println("\nTest with user transaction (situation #1)");
	    	System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    	System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    	System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    	System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    	System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    	System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    	System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    	System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    	// the next line leads to an exception (situation #1)
	    	System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    }
	    catch (Exception ex) {
	    	ex.printStackTrace();
	    }
	    finally {
	    	ut.rollback();
	    }
	    
	    // second try, with a new testXPCSFSB1a (the old one got destroyed a few lines above)
		testXPCSFSB1a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB1!xpctest.TestBean?stateful");

	    ut = EJBClient.getUserTransaction("xpctest");
	    ut.begin();
		
	    try {
	    	System.out.println("\nTest with user transaction (situation #2)");
	    	System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    	// the next line leads to an exception (situation #2)
	    	System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    }
	    catch (Exception ex) {
	    	ex.printStackTrace();
	    }
	    finally {
	    	ut.rollback();
	    }
	    
	    // third try, with a new testXPCSFSB1a (the old one got destroyed a few lines above)
		testXPCSFSB1a = (TestBean)ctx.lookup("ejb:xpc-wildfly/xpc-wildfly-beans//TestXPCSFSB1!xpctest.TestBean?stateful");

	    ut = EJBClient.getUserTransaction("xpctest");
	    ut.begin();
		
	    try {
	    	System.out.println("\nTest with user transaction (situation #3)");
	    	System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    	// the next line leads to an exception (situation #3)
	    	System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    }
	    catch (Exception ex) {
	    	ex.printStackTrace();
	    }
	    finally {
	    	ut.rollback();
	    }

	    ctx.close();
	}
}